/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/

package extThopt;

import extThopt.*;
import java.util.*; 
import com.sun.java.swing.*;

public class DeSuperHeater extends ExtMixer implements External
{
    
	com.sun.java.swing.JLabel JLabel2 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField deltaP_factor_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JCheckBox JCheckSaturation = new com.sun.java.swing.JCheckBox();
	com.sun.java.swing.JLabel JLabel6 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField deltaTsat_value = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel10 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField compRef = new com.sun.java.swing.JTextField();
	com.sun.java.swing.JLabel JLabel7 = new com.sun.java.swing.JLabel();
	com.sun.java.swing.JTextField outletT_value = new com.sun.java.swing.JTextField();
    
    double DeltaP_factor,m_desurch,mLiquid,X_liquid,mSteam,P_steam,T_steam,H_steam,H_liquid,H_desurch,T_desurch,P_desurch,T_liquid,P_liquid,S_liquid,S_steam,X_steam,Smix;
    String desurchProcess,steamProcess,liquidProcess;
    String desurchPoint,steamPoint,liquidPoint;
        
    Vector[]vTransfo,vPoints;
    rg.corps.Corps steam;
    
    public DeSuperHeater (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JLabel2.setText("Pout/Pin factor");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,0,164,20);
		JPanel1.add(deltaP_factor_value);
		deltaP_factor_value.setBounds(164,0,124,20);
		deltaP_factor_value.setText("0.98");
		JCheckSaturation.setText("saturated vapor");
		JPanel1.add(JCheckSaturation);
		JCheckSaturation.setBounds(0,66,164,20);
		JLabel6.setText("\u0394T superheat (C)");
		JPanel1.add(JLabel6);
		JLabel6.setBounds(0,88,164,20);
		JPanel1.add(deltaTsat_value);
		deltaTsat_value.setBounds(164,88,124,20);
		deltaTsat_value.setText("100");
		JLabel7.setText("outlet temperature (C)");
		JPanel1.add(JLabel7);
		JLabel7.setBounds(0,33,164,20);
		JPanel1.add(outletT_value);
		outletT_value.setBounds(164,33,124,20);
		outletT_value.setText("1.0");		
		JLabel10.setText("reference");
		JPanel1.add(JLabel10);
		JLabel10.setBounds(0,186,108,20);
		JPanel1.add(compRef);
		compRef.setBounds(108,186,192,20);
		type=getType();
		thermoCouplerTypes=new String[0];
		compRef.setText("Desuperheater");
    }
    
    public String getType(){
        return "desuperheater";
    }
    
      
	public String getClassDescription(){
	    return "Desuperheater class";
	}

    
	public void calculateProcess(){
	
	    getMixerStructure();
        checkConsistency();
	    
	    if(isBuilt){
	        //lecture du facteur de perte de charge
            DeltaP_factor=Util.lit_d(deltaP_factor_value.getText());
            //mise  jour de la pression aval
            P_desurch=P_steam*DeltaP_factor;
            //lecture de la valeur de la surchauffe  raliser
            double deltaT=Util.lit_d(deltaTsat_value.getText());
            //lecture de la valeur de la temprature de dsurchauffe
            double outletT=Util.lit_d(outletT_value.getText())+273.15;
            //mise  jour de la temprature de dsurchauffe
            if(JCheckSaturation.isSelected())T_desurch=steam.getSatTemperature(P_desurch,1)+deltaT;
            else T_desurch=outletT;
            //calcul de l'tat de sortie dsir
            steam.CalcPropCorps(T_desurch,P_desurch,1) ;
            getSubstProperties(nomCorps);
            H_desurch=Hsubst;
            //calcul du dbit de liquide ncessaire
            mLiquid=mSteam*(H_steam-H_desurch)/(H_desurch-H_liquid);
            //calcul du dbit aval
            m_desurch=mLiquid+mSteam;
            
			//Mise  jour du noeud externe 
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
            setupDesurchProcess(m_desurch,T_desurch,P_desurch,1);
            setupLiquidProcess(mLiquid,T_liquid,P_liquid,X_liquid);
            setupSteamProcess(mSteam,T_steam,P_steam,X_steam);
            updateMixer(vTransfo,vPoints,T_desurch,H_desurch);
            proj.setUpstreamFlow(liquidProcess, mLiquid);//modifie rcursivement les dbits en amont
        }
	}
	
	
    private void setupDesurchProcess(double m, double T, double P, double X){
        vTransfo[0]=new Vector();
        vPoints[0]=new Vector();
        vTransfo[0].addElement(desurchProcess);
        vTransfo[0].addElement(new Double(m));
 
        vPoints[0].addElement(desurchPoint);
        vPoints[0].addElement(new Double(T));
        vPoints[0].addElement(new Double(P));
        vPoints[0].addElement(new Double(X));
    }
    private void setupLiquidProcess(double m, double T, double P, double X){
        vTransfo[1]=new Vector();
        vPoints[1]=new Vector();
        vTransfo[1].addElement(liquidProcess);
        vTransfo[1].addElement(new Double(m));
 
        vPoints[1].addElement(liquidPoint);
        vPoints[1].addElement(new Double(T));
        vPoints[1].addElement(new Double(P));
        vPoints[1].addElement(new Double(X));
    }
    private void setupSteamProcess(double m, double T, double P, double X){
        vTransfo[2]=new Vector();
        vPoints[2]=new Vector();
        vTransfo[2].addElement(steamProcess);
        vTransfo[2].addElement(new Double(m));
 
        vPoints[2].addElement(steamPoint);
        vPoints[2].addElement(new Double(T));
        vPoints[2].addElement(new Double(P));
        vPoints[2].addElement(new Double(X));
    }
  
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        liquidProcess="";
        steamProcess="";
        
        desurchProcess=mainProcess;
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=desurchProcess;//name of the process (see method getProperties(String[] args))
	    Vector vPropMain=proj.getProperties(args);
	    Double f=(Double)vPropMain.elementAt(3);
	    m_desurch=f.doubleValue();
	    String amont=(String)vPropMain.elementAt(1);//gets the upstream point name
	    getPointProperties(amont);//direct parsing of point property vector
	    desurchPoint=amont;
	    T_desurch=Tpoint;
	    P_desurch=Ppoint;
//	    X_desurch=Xpoint;
	    H_desurch=Hpoint;
        String nom=nomCorps;
        args[0]="point";
        args[1]=amont;
	    vPropMain=proj.getProperties(args);
	    steam=(rg.corps.Corps)vPropMain.elementAt(0);

        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 2";
	        JOptionPane.showMessageDialog(me, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String aval=(String)vBranch[j].elementAt(2);//gets the downstream point name
	            getPointProperties(aval);//direct parsing of point property vector
                nom=nomCorps;
                //Check the substance at inlet
                System.out.println(" ligne "+j+" nomBranche[j] "+nomBranche[j]+" aval "+aval+" nomCorps "+nomCorps+" Ppoint "+Ppoint+" P_desurch "+P_desurch);
	            if((Xpoint==0)){//liquide
	                liquidProcess=nomBranche[j];
	                liquidPoint=aval;
	                T_liquid=Tpoint;
	                P_liquid=Ppoint;
	                H_liquid=Hpoint;
	                S_liquid=Spoint;
	                X_liquid=Xpoint;
	                f=(Double)vBranch[j].elementAt(3);
	                mLiquid=f.doubleValue();
	            }
	            if((Xpoint==1)){//vapeur
	                steamProcess=nomBranche[j];
	                steamPoint=aval;
	                P_steam=Ppoint;
	                H_steam=Hpoint;
	                S_steam=Spoint;
	                T_steam=Tpoint;
	                X_steam=Xpoint;
	                f=(Double)vBranch[j].elementAt(3);
	                mSteam=f.doubleValue();
	            }
	        }
	        if((steamProcess.equals(""))||(liquidProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(me, msg);  
	            isBuilt=false;
	        }
        }
    }

	public void readCompParameters(String ligne_data){
		double P_fact=Util.lit_d(Util.extr_value(ligne_data, "deltaP_factor_value"));
	    deltaP_factor_value.setText(Util.aff_d(P_fact,5));
	    String val=Util.extr_value(ligne_data, "deltaTsat_value");
		if(val!=null)deltaTsat_value.setText(val);
		val=Util.extr_value(ligne_data, "saturationT");
		if(val!=null)JCheckSaturation.setSelected(Util.lit_b(val));
		val=Util.extr_value(ligne_data, "outletT_value");
	    if(val!=null)outletT_value.setText(val);
        String valeur=Util.extr_value(ligne_data, "compRef");
        if(valeur!=null)compRef.setText(valeur);
	} 
	
    public String saveCompParameters(){
	    String h="deltaP_factor_value="+deltaP_factor_value.getText()+tab
	    +"deltaTsat_value="+deltaTsat_value.getText()+tab
	    +"saturationT="+Util.aff_b(JCheckSaturation.isSelected())+tab
	    +"outletT_value="+outletT_value.getText()+tab
	    +"compRef="+compRef.getText()+tab
	    ;
        return h;
    }
 

}